﻿using System;
using System.IO;
using System.Reflection;

namespace XmlSerializersTest
{
    class HelperAssemblyLoader
    {
        public static Assembly AssemblyResolve(object sender, ResolveEventArgs args)
        {
            AssemblyName name = new AssemblyName(args.Name);
            string path = Assembly.GetEntryAssembly().Location;
            string binDir = Path.GetDirectoryName(path);
            string solutionDir = Path.Combine(binDir, @"..\..\..");
            string assemblySubDir = String.Format(@"{0}_{1}_{2}\bin\Debug", name.Name, name.Version.Major, name.Version.Minor);
            string assemblyDir = Path.Combine(solutionDir, assemblySubDir);
            if (!Directory.Exists(assemblyDir)) return null;

            string assemblyFile = Path.Combine(assemblyDir, name.Name + ".dll");
            if (!File.Exists(assemblyFile)) return null;
            return Assembly.LoadFrom(assemblyFile);
        }
    }
}
